//
//  BTDataProcessVC.h
//  Unity-iPhone
//
//  Created by leon on 2021/2/3.
//

#import <UIKit/UIKit.h>
#import <CoreBluetooth/CoreBluetooth.h>
#import "MYFactoryManager.h"
#import "LEONBLManager.h"
#import "CBPeripheral+ADName.h"

//游戏类型
typedef NS_ENUM(int, GAME_TYPE){
    GAME_TYPE_DEMO =0, //
    GAME_TYPE_RUN, //
    GAME_TYPE_DANCE, //
    GAME_TYPE_SDAER, //
};

//动作数据
typedef NS_ENUM(NSInteger, GAME_MOTION){
    MOTION_STOP =0,
    MOTION_RUN,// 跑
    MOTION_JUMP, // 跳
    MOTION_DOWN, // 蹲
    MOTION_LEFT, // 滑左
    MOTION_RIGHT, // 滑右
    MOTION_FRONT, // 滑前
    MOTION_BACK, // 滑后
    MOTION_LEFT_UP, // 点击-左上
    MOTION_LEFT_DOWN, // 点击-左下
    MOTION_RIGHT_UP, // 点击-右上
    MOTION_RIGHT_DOWN, // 点击-右下
    MOTION_STEP, // 点击-原地踩
    NUMBERS_OF_MOTION
};

//蓝牙状态
typedef NS_ENUM(NSInteger, BLETOOTH_STUTAS){
    CONNECT_DIS =0, // 未链接
    CONNECT_ING , //链接中
    CONNECT_ED,// 已链接
    CONNECT_LOST, // 丢失链接 /链接失败
};

@interface BTDataProcess : UIViewController
    
//app 跳转传过来的mac 实际是蓝牙设备的identity
@property(copy,nonatomic)NSString * macAddress;
//弹窗 unity主动选择链接 主0 副1 设备
@property(assign,nonatomic)DEVICE_TYPE deviceType;
//游戏种类 1是跳舞 3是跑酷 2是赛达尔传说 4是demo->dance
@property(assign,nonatomic)GAME_TYPE game_id;
//蓝牙设备数据源回调给popSeaechView
@property(copy,nonatomic)void (^deviceArrBLock)(NSMutableArray*arr);
//主设备跳起 下蹲 步数 的总数
@property(assign,nonatomic)int jump_count;
@property(assign,nonatomic)int crouch_count;
@property(assign,nonatomic)int step_count;
//步数回调缓存
@property(copy,nonatomic)void (^allMotionCountBLock)(int jump_count,int crouch_count,int step_count);//蓝牙设备数据源
//脚步交互数据
@property(copy,nonatomic)void (^getInteractionBlock)(int interaction);//蓝牙设备数据源

@property(assign,nonatomic)int isBackGround;//程序在前台还是后台

//单例->初始化蓝牙
+(instancetype)sharedInstance;
//初始化中心管理
-(void)initCBCentralManager;
//app跳转直接连 或 tableview 选中
-(void)connectPeripheral:(CBPeripheral*)peripheral;
//unity或者趣动请求 外部断开蓝牙链接
-(void)disConnedctBle;
//
-(void)applicationWillEnterForeground;

@end



