//
//  MYFactoryManager.h
//  GoHiking_app
//
//  Created by dwl on 17/10/13.
//  Copyright (c) 2017年 dwl. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

//tool
//#import "MYFactoryManager.h"
#import "UIView+ST.h"
#import "AlgorithmTool.h"
#import "UIColor+Hex.h"

//#import "IOSPlatformSDK.h"
//
//蓝牙
#import <CoreBluetooth/CoreBluetooth.h>
#import "BTDataProcess.h"
//蓝牙提供的sdk算法
#import "GameObjc.h"
#define LEFT_FOOT_OC 1
#define RIGHT_FOOT_OC 2
//蓝牙框架封装
#import "LEONBLManager.h"
#define LEManager [LEONBLManager sharedInstance]

//http
#import "HTTPDataProcession.h"
#import "UserFriendsModel.h"
//第三方
#import "AFNetworking.h"
#import "MBProgressHUD.h"
//UI
#import "SearchDeviceViewController.h"
#import "AnimationView.h"
#import "PopupView.h"
#import "NoDeviceTip.h"

/*************************** 获取屏幕 宽度、高度 ***************************/
#define SCREEN_WIDTH ([UIScreen mainScreen].bounds.size.width)
#define SCREEN_HEIGHT ([UIScreen mainScreen].bounds.size.height)
/*************************** 状态栏+导航栏 高度 ***************************/
#define getRectNavAndStatusHight  self.navigationController.navigationBar.frame.size.height+[[UIApplication sharedApplication] statusBarFrame].size.height
#define getTarbarHight (SCREEN_HEIGHT>=812?83:49)
/*************************** 比例系数布局  ***************************/
#define SCALEoefficient(num)   (SCREEN_WIDTH/667.0)*(num)
#define SCALE_HIGHT_oefficient(num)   (SCREEN_HEIGHT/375.0)*(num)
/*************************** 字号大小  ***************************/
#define SCALEoefficient_20 20.0*(SCREEN_WIDTH/320.0)///<大标题
#define SCALEoefficient_18 18.0*(SCREEN_WIDTH/320.0)///<附标题
#define SCALEoefficient_16 16.0*(SCREEN_WIDTH/320.0)///<中标题
#define SCALEoefficient_14 14.0*(SCREEN_WIDTH/320.0)///<小标题

//app跳转 用户信息
#define IOSSDK_USERINFO @"iosSdk_userInfo"
//缓存的步频数据
#define IOSSDK_BLESDKDATA @"iosSdk_bleSdk_frequency"
//游戏组数时间戳 参数是play_gorup
#define IOSSDK_TIMESTAMP @"iosSdk_timestamp"
//custom System UserDefaults
#define IOS_NSUSERDEFAULT [NSUserDefaults standardUserDefaults]
#define CUS_NOTIFICATIONCENTER [NSNotificationCenter defaultCenter]
#define IOSSDK_TOKEN [[IOS_NSUSERDEFAULT objectForKey:IOSSDK_USERINFO] objectForKey:@"token"]
#define IOSSDK_GAMEID [[IOS_NSUSERDEFAULT objectForKey:IOSSDK_USERINFO] objectForKey:@"game_id"]
//#define IOSSDK_GAMEID @"3"
//#define IOSSDK_TOKEN @"shoes:61652aa99523f9.65681365I94"

@interface MYFactoryManager : NSObject

@property (nonatomic,assign) UIBackgroundTaskIdentifier bgTask;

#pragma mark -- UI
//单例
+(instancetype)sharedInstance;
//边框
+ (void)makeBoundsWithView:(UIView *)view color:(UIColor *)color width:(CGFloat)width;
//圆角
+ (void)clipsToBoundsWithView:(UIView *)view Radius:(NSInteger)radius;
/**高度自适应*/
+ (CGFloat)heightForString:(NSString *)string fontSize:(CGFloat)fontSize andWidth:(CGFloat)width;
/**宽度自适应*/
+ (CGFloat)widthForString:(NSString *)string fontSize:(CGFloat)fontSize andHeight:(CGFloat)height;
//正常加载还是打包后sdk加载
+(UIImage*)imageString:(NSString*)imageName;
//发送测试group通知
+(void)postGroupCFNotificaiton:(NSString*)string;
//开启后台任务保活
-(void)comeToBackgroundMode;
//#pragma mark -- 参数判断
//+(BOOL)ifLoogIn:(BOOL)tip;
//+(bool)internetStatus;
//
//#pragma mark -- 各类弹窗
//+(void)popChooseSSIDListViewController;
//
//#pragma mark -- 授权
//+(BOOL)authorizationCarmen;
//
//#pragma mark -- 正则
////获取*****手机格式
//+ (NSString *)getPhoneText:(NSString *)phoneNum;
////手机格式
//+ (BOOL)phoneNum:(NSString *) textString;
////检测是否为邮箱
//+ (BOOL)emailNum:(NSString *)emailStr;
//
//
////字符串转字典与字典转字符串
//+ (NSDictionary *)parseJSONStringToNSDictionary:(NSString *)JSONString;
//+ (NSString*)dictionaryToJson:(NSDictionary *)dic;
//+ (NSString*)arrayToJson:(NSArray *)arr;
//+ (NSArray *)parseJSONStringToNSArray:(NSString *)JSONString;
//
////时间计算
//+ (NSString*)returnNowDateString;
//+ (NSString*)returnNowTimeString;
//+ (NSString *)getStartTimeDate:(NSNumber *)dateTime format:(NSString *)format;
//+ (NSString *)returnUploadTime:(NSString *)timeStr;
//+ (NSString *)getRealTime:(NSString *)dateTime format:(NSString *)format;
//+ (NSString *)returnTimestamp:(NSString *)timeStr;
//+ (void)countdownWith:(UIButton *)but;//倒计时
//
//#pragma mark -------------------------------------------------------------------------------------- 勒夫曼德
////16位数字MD5加密
//+ (NSString *)getMd5_16Bit_String:(NSString *)srcString;
////将十六进制的字符串转换成NSString则可使用如下方式:
//+ (NSString *)convertHexStrToString:(NSString *)str;
////将NSString转换成十六进制的字符串则可使用如下方式:
//+ (NSString *)convertStringToHexStr:(NSString *)str;
////十六进制转换为二进制
//+ (NSString *)convertDataToHexStr:(NSData *)data;
////温度图文混排富文本
//+(NSAttributedString*)labelAttribute:(NSString*)firstLabelText  secondLabelText:(NSString*)secondLabelText;
////修改头部视图背景
//+(NSString*)changePicturesAccordingToPeriods;
////国际化地名简体转拼音
//+ (NSString *)transform:(NSString *)chinese;
////返回档位信息
//+(NSString*)returnStallStr:(NSString*)command deviceinfo:(NSString*)deviceinfo;
////返回天气图片
//+(NSString*)returnWeatherImageStr:(NSString*)deviceInfo;
////返回室外天气
//+(NSString*)returnOutDoorAqi:(NSInteger)aqiValue;
////验证报文
//+(NSString*)authenticationMessage:(NSString*)MessageConent;
////获取当前手机连接的wifi是否是luftmed-
//+ (NSString*)getCurrentSSID;
//+ (BOOL)ifConnetLuftmed;
////获取UDID
//+(NSString*)getUDIDString;
////返回PM25污染度对应的文本
//+(NSString*)getPM25ValueText:(NSString*)value;
////返回PM25污染度对应的颜色
//+(UIColor*)getPM25ValueColor:(NSString*)value;
////返回PM25污染度对应角度
//+(CGFloat)getPM25TotalAngle:(NSInteger)temp10;
////返回TVOC污染度对应的文本
//+(NSString*)getTVOCValueText:(NSString*)value;
////返回TVOC污染度对应的颜色
//+(UIColor*)getTVOCValueColor:(NSString*)value;
////TVOC真实值
//+(NSString*)returnRealTVOCValue:(NSString*)value;
//
//#pragma mark -------------------------------------------------------------------------------------- 车载相关
////或异算法
//+(NSString*)HardDriveVerificationAlgorithm:(NSString*)string_input;
////字符串转16进制数据流 -- 用于蓝牙发送
//+(NSData *)convertHexStrToData:(NSString *)str;
////单个16进制字节-转换-》10进制
//+(NSInteger)hexToInt:(NSString*)hex;
//


@end
