//
//  SearchDeviceViewController.m
//  Unity-iPhone
//
//  Created by leon on 2021/2/4.
//

#import "SearchDeviceViewController.h"

#import "TXCarouselView.h"
#import "ShoesCarouselView.h"

@interface SearchDeviceViewController ()<ConnectDeviceDelegate>
//
@property (strong, nonatomic)ShoesCarouselView * shoesCarouselView;
@property (nonatomic, strong) NSMutableArray *array;

//button
@property(nonatomic,strong)UIButton * nextButton;//
@property(nonatomic,strong)UIButton * lastButton;//
@property(nonatomic,strong)UIButton * searchButton;//
@property(nonatomic,strong)UIButton * connectButton;//

//留白
@property(nonatomic,strong)NoDeviceTip * tipView;

@end

@implementation SearchDeviceViewController

-(void)viewDidLoad{
    
    [super viewDidLoad];
    
    [self initUI];
    
}

#pragma mark -- create UI
-(void)initUI{
    
    //创建需要的毛玻璃特效类型
    UIBlurEffect *blur = [UIBlurEffect effectWithStyle:UIBlurEffectStyleDark];
    //创建毛玻璃视图
    UIVisualEffectView *visualV = [[UIVisualEffectView alloc] initWithEffect:blur];
    visualV.frame = self.view.bounds;
    //可以通过透明度来达到模糊程序的改变.
    visualV.effect = nil;
    visualV.backgroundColor = [UIColor blackColor];
    visualV.alpha = 0.5;
    [UIView animateWithDuration:1 animations:^{
        visualV.effect = blur;
    }];
    [self.view addSubview:visualV];
    
    //留白
    [self.view addSubview:self.tipView];
        
    //设备列表
    self.shoesCarouselView  = [[ShoesCarouselView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH-SCALEoefficient(200), SCREEN_HEIGHT-SCALEoefficient(100))];
    self.shoesCarouselView.centerX = self.view.centerX;
    self.shoesCarouselView.centerY = self.view.centerY-20;
    [self.view addSubview:self.shoesCarouselView];
    self.shoesCarouselView.delegate = self;
    
    //好友列表
//    self.carouselView  = [[TXCarouselView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH-300, SCREEN_HEIGHT-150)];
//    self.carouselView.centerX = self.view.centerX;
//    self.carouselView.centerY = self.view.centerY-20;
//    [self.view addSubview:self.carouselView];
    
    //上一个
    self.nextButton = [UIButton buttonWithType:UIButtonTypeSystem];
    self.nextButton.frame = CGRectMake(0, 0, SCALEoefficient(16), SCALEoefficient(32));
    self.nextButton.centerY = self.shoesCarouselView.centerY;
    self.nextButton.right = self.shoesCarouselView.left+10;
    [self.nextButton setBackgroundImage:[MYFactoryManager imageString:@"gamepop_leftarrow"] forState:UIControlStateNormal];
    [self.view addSubview:self.nextButton];
    [self.nextButton addTarget:self action:@selector(lastAction) forControlEvents:UIControlEventTouchUpInside];
    self.nextButton.backgroundColor = [UIColor clearColor];

    //下一个
    self.lastButton = [UIButton buttonWithType:UIButtonTypeSystem];
    self.lastButton.frame = CGRectMake(0, 0, SCALEoefficient(16), SCALEoefficient(32));
    self.lastButton.centerY = self.shoesCarouselView.centerY;
    self.lastButton.left = self.shoesCarouselView.right-10;
    [self.lastButton setBackgroundImage:[MYFactoryManager imageString:@"gamepop_rihtarrow"] forState:UIControlStateNormal];
    [self.view addSubview:self.lastButton];
    [self.lastButton addTarget:self action:@selector(nextAction) forControlEvents:UIControlEventTouchUpInside];
    self.lastButton.backgroundColor = [UIColor clearColor];
    
    //关闭弹窗
    self.searchButton = [UIButton buttonWithType:UIButtonTypeCustom];
    self.searchButton.frame = CGRectMake(SCREEN_WIDTH/2-SCALEoefficient(160)-20, self.shoesCarouselView.bottom-10, SCALEoefficient(160), SCALEoefficient(40));
    [self.searchButton setTitle:@"关闭弹窗" forState:UIControlStateNormal];
    [self.searchButton setImage:[MYFactoryManager imageString:@"gamepop_close"] forState:UIControlStateNormal];
    [self.searchButton setFont: [UIFont systemFontOfSize: SCALEoefficient(14)]];
    [self.searchButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [self.view addSubview:self.searchButton];
    [self.searchButton addTarget:self action:@selector(close) forControlEvents:UIControlEventTouchUpInside];
    self.searchButton.backgroundColor = [UIColor whiteColor];
    self.searchButton.layer.masksToBounds = YES;
    self.searchButton.layer.cornerRadius = SCALEoefficient(20);
    [self.searchButton setImageEdgeInsets:UIEdgeInsetsMake(0, SCALEoefficient(-15), 0, 0)];
//    self.searchButton.imageView.contentMode = UIViewContentModeScaleAspectFill;
    
    //链接设备
    self.connectButton = [UIButton buttonWithType:UIButtonTypeCustom];
    self.connectButton.frame = CGRectMake(SCREEN_WIDTH/2+20, self.shoesCarouselView.bottom-10, SCALEoefficient(160), SCALEoefficient(40));
    [self.connectButton setTitle:@"连接设备" forState:UIControlStateNormal];
    [self.connectButton setImage:[MYFactoryManager imageString:@"gamepop_determine"] forState:UIControlStateNormal];
    [self.connectButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [self.connectButton setFont: [UIFont systemFontOfSize: SCALEoefficient(14)]];
    [self.view addSubview:self.connectButton];
    [self.connectButton addTarget:self action:@selector(selectedDeviceAction) forControlEvents:UIControlEventTouchUpInside];
    self.connectButton.backgroundColor = [UIColor colorWithRed:255/255.0 green:221/255.0 blue:0/255.0 alpha:1.0];
    self.connectButton.layer.masksToBounds = YES;
    self.connectButton.layer.cornerRadius = SCALEoefficient(20);
    [self.connectButton setImageEdgeInsets:UIEdgeInsetsMake(0, SCALEoefficient(-15), 15, 0)];
//    self.connectButton.imageView.contentMode = UIViewContentModeScaleAspectFit;
    
    NSArray * array = @[@"gamepop_leftarrow_notes",@"gamepop_rihgtarrow_notes",@"gamepop_close_notes",@"gamepop_determine_notes"];
    NSArray * titleArray = @[@"左踩 · 上一个",@"右踩 · 下一个",@"左垫脚 · 关闭",@"右垫脚 · 确认"];

    for (int i =0; i<4; i++){
        UIButton * searchButton = [UIButton buttonWithType:UIButtonTypeCustom];
        searchButton.frame = CGRectMake(SCREEN_WIDTH-SCALEoefficient(62+20+20)*(4-i),SCALEoefficient(23), SCALEoefficient(62+20), SCALEoefficient(20));
        [searchButton setTitle:titleArray[i] forState:UIControlStateNormal];
        [searchButton setImage:[MYFactoryManager imageString:array[i]] forState:UIControlStateNormal];
        [searchButton setFont: [UIFont boldSystemFontOfSize: SCALEoefficient(10)]];
        [searchButton.titleLabel setTextColor:[UIColor whiteColor]];
        [self.view addSubview:searchButton];
//        searchButton.tag = i;
//        [searchButton addTarget:self action:@selector(mapBtnClick:) forControlEvents:UIControlEventTouchUpInside];
//        searchButton.backgroundColor = [UIColor yellowColor];
        [searchButton setImageEdgeInsets:UIEdgeInsetsMake(0, SCALEoefficient(-10), 0, 0)];
//        searchButton.imageView.contentMode = UIViewContentModeScaleAspectFill;
    }
    
//    NSArray *arrayStr = [NSArray arrayWithObjects:
//                         @"1111111111111111111111111111111111111111111111",
//                         @"2222222222222222222222222222222222222222222222",
//                         @"3333333333333333333333333333333333333333333333",
//                         @"4444444444444444444444444444444444444444444444",
//                         @"5555555555555555555555555555555555555555555555",
//                         nil];
//    for (int i = 0; i<arrayStr.count; i++){
//        TXCarouselCellModel *model = [[TXCarouselCellModel alloc]init];
//        model.imageUrl = [NSString stringWithFormat:@"zongshujidaowojia%d",i+1];
//        model.titleStr = arrayStr[i];
//        model.newsId = i;
//        [self.array addObject:model];
//    }
//    [self.shoesCarouselView setArrayData:arrayStr];
//    [self.carouselView setArrayData:arrayStr];
    
}

#pragma mark -------------- 外部事件
//刷新蓝牙数据
-(void)reloadData{
    
    NSMutableArray * dataArr = [NSMutableArray new];
    for (int i = 0; i<self.deviceArray.count; i++){
        TXCarouselCellModel *model = [[TXCarouselCellModel alloc]init];
        model.newsId = i;
        model.peripheral = self.deviceArray[i];
        NSLog(@"model.peripheral === >> %@",model.peripheral.name);
        [dataArr addObject:model];
    }
    [self.shoesCarouselView setArrayData:dataArr];
    
    if (dataArr.count==0){
        self.tipView.hidden = NO;
    }else{
        self.tipView.hidden = YES;
    }
    
}

//蓝牙传过来的脚步交互动作
-(void)getInteraction:(int)interaction{
    
    if (interaction == 0){//原地 -- 复位
        
    }else if(interaction == 3){//左踩 -- 选中上一个设备
        
        [self nextAction];
        
    }else if(interaction == 4){//右踩 -- 选中下一个设备
        
        [self lastAction];
        
    }else if(interaction == 5){//左垫脚 -- 关闭弹窗
        
        [self close];
        
    }else if(interaction == 6){//右垫脚 -- 链接设备
     
        if (self.connectDeviceBlock){
            self.connectDeviceBlock(self.currentPeripheral);
        }
        [self close];
        
    }
    
}

////点击搜索按钮（暂留）
//-(void)searchAction{
//
//    self.tipView.hidden = NO;
//    if(self.searchDeviceTask){
//        self.searchDeviceTask();
//    }
//
//}

#pragma mark -------------- 点击界面交互Action
//选中上一个设备
- (void)lastAction{
    [_shoesCarouselView yw_gotoNext:-1];
}

//选中下一个设备
-(void)nextAction{
    [_shoesCarouselView yw_gotoNext:1];
}

//关闭弹窗
-(void)closeAction{
    [self close];
}

//确认选中的设备 开始蓝牙连接
-(void)selectedDeviceAction{
    
    if (self.connectDeviceBlock){
        self.connectDeviceBlock(self.currentPeripheral);
    }
    [self close];
    
}

//关闭毛玻璃遮罩
- (void)close{

    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.4 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [UIView animateWithDuration:0.25 animations:^{
            self.view.alpha = 0;
            [self.view  removeFromSuperview];
        }completion:^(BOOL finished){
            [self.view  removeFromSuperview];
        }];
    });
    
}


#pragma mark -------------- shoesCarouseView delegate
//来自shoesCarouseView被选中的当前蓝牙
-(void)connectDevice:(CBPeripheral*)peripheral{
    self.currentPeripheral = peripheral;
}


#pragma mark -------------- lazy
-(NSMutableArray*)deviceArray{

    if (!_deviceArray){
        _deviceArray = [NSMutableArray new];
    }
    return _deviceArray;
    
}

-(NoDeviceTip*)tipView{
    
    if (!_tipView){
        _tipView = [[NoDeviceTip alloc] initWithFrame:CGRectMake(SCREEN_WIDTH/2-50, SCREEN_HEIGHT/2-100, 100, 150)];
        _tipView.hidden = NO;
//        _tipView.backgroundColor = [UIColor redColor];
    }
    return _tipView;
    
}

@end
