
#include "tricycle.h"

#define  PI 3.141592653f


Tricycle::Tricycle()
{
	memset(result, -1, 4 * sizeof(int));
	result[0] = 0;

	left_zupt_count = 0;
	right_zupt_count = 0;

	left_foot_init_heading = 0.0f;
	right_foot_init_heading = 0.0f;

	left_trigger_time = 0;
	right_trigger_time = 0;

	last_left_zupt = 1;
	last_right_zupt = 1;

	memset(last_left_pos, 0, 3 * sizeof(int));
	memset(last_right_pos, 0, 3 * sizeof(int));
	
	left_jump_status = 0;
	right_jump_status = 0;

	has_init = 0;

}

void Tricycle::Process(int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_press,
	int jump, int down, int rssi)
{
	//1ȷʼķ

	if (left_zupt)
	{
		left_zupt_count++;
	}
	else
	{
		left_zupt_count = 0;
	}

	if (right_zupt)
	{
		right_zupt_count++;
	}
	else
	{
		right_zupt_count = 0;
	}

	float cur_left_heading = left_att[0] * 0.0001f;
	float cur_right_heading = right_att[0] * 0.0001f;

	//ʼ
	if (left_zupt_count > 100 && right_zupt_count > 100 && rssi < 32)
	{
		left_foot_init_heading  = cur_left_heading;
		right_foot_init_heading = cur_right_heading;

		has_init = 1;
	}


	float left_heading_offset  = calHeadingOffset(left_foot_init_heading, cur_left_heading);

	float right_heading_offset = calHeadingOffset(right_foot_init_heading, cur_right_heading);


	if (fabsf(calHeadingOffset(left_heading_offset, right_heading_offset)) > PI/3.0f)
	{
		std::cout<< "dual_foot_heading appear max angle" <<endl;
	}


	float game_heading_offset = (left_heading_offset + right_heading_offset) * 0.5f;

	//std::cout << "ǰ " << game_heading_offset / PI * 180.0f<<endl;

	//2ͷŵ
	//һʱ㣬ôж˫ͬʱأ0.5SҵĴСȴźŵͬʱ

	int down_prop = -1;

	int up_prop = -1;

	if (jump && left_trigger_time == 0 && right_trigger_time == 0)
	{
		left_jump_status = 1;
		right_jump_status = 1;

		std::cout << "г" << endl;
	}

	if (left_zupt && last_left_zupt == 0 && left_trigger_time == 0 && left_jump_status == 1)
	{
		left_trigger_time = 50;

		if (left_pos_offset < -10)
		{
			left_jump_status = 2;
		}
		else if (left_pos_offset > 10)
		{
			left_trigger_time = 0;
			left_jump_status = 0;

			std::cout << "Ž״̬ȫΪ0" << endl;
		}

	}


	if (left_zupt && last_left_zupt == 0)
	{
		std::cout << "left_zupt && last_left_zupt == 0" << endl;

		std::cout << "left_jump_status : " << left_jump_status << endl;

		std::cout << "left_trigger_time : " << left_trigger_time << endl;
	}



	if (right_zupt && last_right_zupt == 0 && right_trigger_time == 0 && right_jump_status == 1)
	{
		right_trigger_time = 50;

		if (right_pos_offset > 10)
		{
			right_jump_status = 2;
		}
		else if (right_pos_offset < -10)
		{
			right_jump_status = 0;

			right_trigger_time = 0;

			std::cout << "ҽŽ״̬ȫΪ0" << endl;
		}
	}

	if (right_zupt && last_right_zupt == 0)
	{
		std::cout << "right_zupt && last_right_zupt == 0" << endl;

		std::cout << "right_jump_status : " << right_jump_status <<endl;

		std::cout << "right_trigger_time : " << right_trigger_time << endl;
	}



	if( right_trigger_time > 0 && left_trigger_time > 0)
	{
		//ͷƷ

		std::cout << "debug : if( right_trigger_time > 0 && left_trigger_time > 0)" << endl;

		if (right_jump_status == 1 && left_jump_status == 1)
		{
			up_prop = 1;

			std::cout << "ϲ Ʒ" << endl;
		}
		else if (right_jump_status == 2 && left_jump_status == 2)
		{
			down_prop = 1;

			std::cout << "² Ʒ" << endl;
		}
		else
		{
			std::cout << "debug : right_jump_status : " << right_jump_status << "left_jump_status :" << left_jump_status << endl;
		}

		right_trigger_time = 0;
		left_trigger_time = 0;
	}

	if (left_trigger_time > 0)
	{
		left_trigger_time --;
	}

	if (right_trigger_time > 0)
	{
		right_trigger_time--;
	}


	if (left_zupt)
	{

		for (int i = 0; i < 3; i++)
		{
			last_left_pos[i] = left_pos[i];
		}

		if(left_trigger_time == 0)
			left_jump_status = 0;
	}

	left_pos_offset = left_pos[0] - last_left_pos[0];

	if (right_zupt)
	{
		for (int i = 0; i < 3; i++)
		{
			last_right_pos[i] = right_pos[i];
		}
		if(right_trigger_time == 0)
			right_jump_status = 0;
	}

	right_pos_offset = right_pos[0] - last_right_pos[0];

	last_left_zupt = left_zupt;
	last_right_zupt = right_zupt;


	result[0] = (int)(game_heading_offset * 10000.0f);

	result[1] = up_prop;
	result[2] = down_prop;

	if (has_init == 0)
	{
		result[0] = 0;
	}

}

float Tricycle::calHeadingOffset(float init_heading, float cur_heading)
{
	float heading_offset = cur_heading - init_heading;

	if (heading_offset > PI)
	{
		heading_offset = -(2 * PI - heading_offset);
	}
	else if (heading_offset < -PI)
	{
		heading_offset = (2 * PI + heading_offset);
	}

	return heading_offset;
}

void Tricycle::getResult(int* dec)
{
	memcpy(dec, result, 4 * sizeof(int));
}